VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "aeDNS"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Member0" ,"ceDNSNotify"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

'AzUrE
'Copyright (C) 2000 Sam Smith All Rights Reserved
'
'Contact: <samuel.smith@nme.com>
'Version: 1.0.0.0
'
'This software is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

Private Type hDNSData
  'Object pointer to this class
  hClassPtr As Long
  'Object Pointer to the event class interface
  hEventPtr As Long
  'Handle given by DNSAPI for the current "lookup" if any
  hDNS As Long
  'Time taken in ticks for a task to complete
  hTime As Long
  'String containing passed host we are looking up if any
  StrHost As String
  'Struct containing DNS data, needs to be parsed
  hLookUpData As hostentA
  'Data to be passed back
  hLong As Long
End Type

'private local copy of our UDT
Private hData As hDNSData

Implements aeSubclass

Private mvarTimeout As Long
Private mvarTimerRunning As Boolean

Private Const ceDNSError_Base = 10400
Private Const ceDNSError_NullStr = (ceDNSError_Base + 1)
Private Const ceDNSError_FatalDecode = (ceDNSError_Base + 2)

Private Function gErrStr(ByVal ErrorCode As Long) As String
  Select Case ErrorCode
    Case 0
      gErrStr = "No Error"
    Case ceDNSError_NullStr
      gErrStr = "An empty host string was passed"
    Case ceDNSError_FatalDecode
      gErrStr = "There was an error whilst trying to feedback DNS information"
    Case Else
      gErrStr = "Error not defined"
  End Select
End Function

Public Property Let TimeOut(ByVal vData As Long)
  On Error GoTo gErr:
  If vData <> mvarTimeout Then
    If vData < 0 Then vData = 1
    SetProp ws_hwnd, CStr(hData.hClassPtr & "#timercount"), 0
    mvarTimeout = vData
  End If
gErr:
  Err.Clear
End Property
Public Property Get TimeOut() As Long
    TimeOut = mvarTimeout
End Property

Private Sub Class_Initialize()
 'Keep long pointer to class, better than many ObjPtr calls
 hData.hClassPtr = ObjPtr(Me)
End Sub
Private Sub Class_Terminate()

  'Cancel any calls!
  CancelDNS

  With hData
  'Remove subclass message(s) before shutting down winsock
  'ceDetachMessage Me, ws_hwnd, DNS_REPLY
  'Stop the timer!
  DettachTimer
  .hTime = 0
  .hClassPtr = 0
  .hEventPtr = 0
  .hDNS = 0
  
  End With
End Sub

Private Function aeSubclass_WindowProc( _
  ByVal hwnd As Long, _
  ByVal iMsg As Long, _
  ByVal wParam As Long, _
  ByVal lParam As Long) As Long
  
  DoEvents
  
  On Error GoTo gErr:
      
  Select Case iMsg
      Case DNS_REPLY
     
      'Stop timeout message
      DettachTimer
      
      Dim iwp As aeDNSNotify, iwpT As aeDNSNotify
      
      Dim lErr As Long
      lErr = GetAsyncError(lParam)
      #If INDEBUG Then
        Debug.Print "Returned Error : " & lErr
      #End If
      
      If lErr <> 0 Then
        With hData
          If wParam = SOCKET_ERROR Then
            'This message was not from winsock!
            WSACancelAsyncRequest .hDNS
            .hDNS = 0
          End If
          If .hEventPtr <> 0 Then
            'Notify event interface
            CopyMemory iwpT, .hEventPtr, 4
            Set iwp = iwpT
            CopyMemory iwpT, 0&, 4
            iwp.DNSNotify .hDNS, .StrHost, "", "", "", False, True, lErr, WSAGetLastErrorMessage(lErr), .hTime, .hLong
          End If
          .hDNS = 0
          .StrHost = ""
          .hTime = 0
          Exit Function
        End With
      End If
      
      With hData
        .hDNS = 0
        'Work out time taken in ticks
        .hTime = (GetTickCount - .hTime)
      End With
           
      'Delete pointer "point" to the msg and this class
      DeleteInterface wParam, "DNS"
      
      #If INDEBUG Then
        Debug.Print "Event pointer = " & hData.hEventPtr
      #End If
      
      'Parse out the host struct
      Dim HostNameB() As Byte
      ReDim HostNameB(0 To 255) As Byte
      'Final result will be kept here
      Dim HostNameStr As String
      Dim ICur As Integer
            
      'Copy pointer to host name to byte array
      CopyMemory ByVal VarPtr(HostNameB(0)), ByVal hData.hLookUpData.h_name, 256
      'Convert byte array into a unicode string
      HostNameStr = StrConv(HostNameB, vbUnicode)
      'Look up first null char (remove null termination)
      ICur = InStr(1, HostNameStr, Chr(0))
      If ICur > 0 Then
        'Found first null char, save behind that position,
        'Trim spaces if any are found
        HostNameStr = Trim(Mid(HostNameStr, 1, ICur - 1))
      End If
      
      Dim IP_Addr_List As Long
      Dim IP_Addr As Long
      Dim IP_Str As String
      
      With hData.hLookUpData
      'Get pointer to IP list (maybe more than one IP address)
      CopyMemory IP_Addr_List, ByVal .h_addr_list, 4
      'Copy first IP address (in long form) by pointer
      CopyMemory IP_Addr, ByVal IP_Addr_List, 4
      'Get noted IP address  by "long" IP address
      IP_Str = GetNotedIP(IP_Addr)
      
      Dim HostNameAliasStr As String
      'Get alias, if returned is zero, there is no alias
      CopyMemory IP_Addr_List, ByVal .h_aliases, 4
      
      If IP_Addr_List <> 0 Then
        'There was an alias, copy pointer to byte array buffer
        CopyMemory ByVal VarPtr(HostNameB(0)), ByVal IP_Addr_List, 256
        'Convert bytearray into string
        HostNameAliasStr = StrConv(HostNameB, vbUnicode)
        'Find first null character
        ICur = InStr(1, HostNameAliasStr, Chr(0))
        If ICur > 0 Then
          'Found, save behind first null character
          HostNameAliasStr = Trim(Mid(HostNameAliasStr, 1, ICur - 1))
        End If
      End If
      
      End With
      
      With hData
        'Notify event interface if it exists
        If .hEventPtr <> 0 Then
          CopyMemory iwpT, .hEventPtr, 4
          Set iwp = iwpT
          CopyMemory iwpT, 0&, 4
          iwp.DNSNotify wParam, .StrHost, IP_Str, HostNameStr, HostNameAliasStr, False, False, 0, "", .hTime, .hLong
        End If
        'Reset vars
        .StrHost = ""
        .hTime = 0
        .hEventPtr = 0
        Exit Function
      End With
      
      
      Case SOCKET_TIMER
      
      'This timeout function is generic
      'It will post a timeout error after a user set interval
      'it does not care about anything else.
      
        If mvarTimeout = 0 Then
          'If timeout ability isn't needed turn off timer and exit
          DettachTimer
          Exit Function
        End If
        Dim lTimerC As Long
        'Get the current time count
        lTimerC = GetProp(hwnd, CStr(hData.hClassPtr & "#timercount"))
        If lTimerC >= mvarTimeout Then
          DettachTimer
          'When timeout happens, send fake error back to ourselves
          'Turn off timer messaging and exit
          SendMessage ws_hwnd, DNS_REPLY, -1, ByVal WSAMakeSelectReply(0, WSAETIMEDOUT)
          Exit Function
        End If
        'Inc the count one and save
        lTimerC = lTimerC + 1
        SetProp hwnd, CStr(hData.hClassPtr & "#timercount"), lTimerC
                
  End Select
  
  Exit Function
gErr:
  #If INDEBUG Then
    Debug.Print "aeSubclass_WindowProc ERR: " & Err.Description
  #End If
  Err.Clear
  If hData.hEventPtr <> 0 Then
      CopyMemory iwpT, hData.hEventPtr, 4
      Set iwp = iwpT
      CopyMemory iwpT, 0&, 4
      iwp.DNSNotify -1, "", "", "", "", True, True, ceDNSError_FatalDecode, gErrStr(ceDNSError_FatalDecode), 0
  End If
End Function

Public Sub CancelDNS()
  With hData
    If .hDNS = 0 Then Exit Sub
    DettachTimer
    WSACancelAsyncRequest .hDNS
    .hDNS = 0
    .hTime = 0
    .StrHost = ""
    .hEventPtr = 0
  End With
End Sub

Public Sub DNS( _
    Host As String, _
    Interface As aeDNSNotify, _
    Optional bAllowReverse As Boolean = False, _
    Optional hTag As Long = 0)
    
    DoEvents
    '
    Host = Trim(Host)
     
    'bAllowReverse will make sure if false
    'an IP address isn't looked up!
    'but passed back as if it were looked up
    'This helps when a class needs only an IP!
    
    'Check that the passed string is something
    'If it is nothing, error and exit
    If Len(Host) = 0 Then
      Interface.DNSNotify -1, "", "" _
      , "", "", True, _
      False, ceDNSError_NullStr, gErrStr(ceDNSError_NullStr), 0, hTag
      Exit Sub
    End If
    
    With hData
      If .hDNS <> 0 Then
        WSACancelAsyncRequest .hDNS
        .hDNS = 0
        .hEventPtr = 0
        .StrHost = ""
        .hTime = 0
      End If
    End With
    
    'Store object pointer to event interface
    hData.hEventPtr = ObjPtr(Interface)
    
    Dim APIVal As Long
    Dim IPVal As Long
    
    IPVal = inet_addr(Host)
    
    If Host = "255.255.255.255" And IPVal = SOCKET_ERROR Then
      'If -1 is returned from inet_addr there maybe still
      'a IP
      IPVal = 0
    End If
    
    With hData
    'Keep current tick count
      .hTime = GetTickCount
      'Store passed tag data
      .hLong = hTag
      'Store passed host
      .StrHost = Host
    End With
    
    DoEvents
    If IPVal = -1 Then
      'Passed string is a host (because it's not an IP!)
      'look up by hostname
      AttachTimer
      APIVal = WSAAsyncGetHostByName( _
      ws_hwnd, DNS_REPLY, _
      Host, hData.hLookUpData, hostentA_size)
    Else
      'Passed string is a IP,
      'but if reverse look up is turned off return IP
      If bAllowReverse = False Then
        Interface.DNSNotify -1, Host, Host, "", "", False, False, 0, "", 0, hTag
        Exit Sub
      End If
      AttachTimer
      APIVal = WSAAsyncGetHostByAddr( _
      ws_hwnd, DNS_REPLY, IPVal, _
      4, 2, hData.hLookUpData, hostentA_size)
    End If
    
    'There was an error, zero isn't a valid handle
    If APIVal = 0 Then
      APIVal = WSAGetLastError
      Interface.DNSNotify -1, Host, "", Host, "", False, _
      False, APIVal, WSAGetLastErrorMessage(APIVal), 0
      With hData
        .hDNS = 0
        .StrHost = ""
        .hTime = 0
        .hEventPtr = 0
      End With
      Exit Sub
    End If
   
   'Mark the handle to be dealt with by a pointer to our subclass interface only.
    SetInterface APIVal, Me, "DNS"
    With hData
    'Store task handle
    .hDNS = APIVal
    End With

End Sub

Private Sub AttachTimer()
  If mvarTimerRunning = True Then Exit Sub
  If mvarTimeout = 0 Then Exit Sub
  SetProp ws_hwnd, CStr(hData.hClassPtr & "#timercount"), 0
  HookTimer Me
  mvarTimerRunning = True
End Sub
Private Sub DettachTimer()
  If mvarTimerRunning = False Then Exit Sub
  UnHookTimer Me
  SetProp ws_hwnd, CStr(hData.hClassPtr & "#timercount"), 0
  mvarTimerRunning = False
End Sub

Public Function IsIPAddress( _
  ByVal IPAddress As String) As Boolean
  If Len(IPAddress) = 0 Then Exit Function
  IsIPAddress = Not IsHost(IPAddress)
End Function
