VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "aeSocketEvent"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

'Must declare enum here to use it when this class is implemented
'otherwise there will be an error (CR)
Public Enum aeSocketState
  Sck_Closed = 0
  Sck_Open = 1
  Sck_Listening = 2
  Sck_ConnectionPending = 3
  Sck_ResolvingHost = 4
  Sck_ResolvedHost = 5
  Sck_Connecting = 6
  Sck_Connected = 7
  Sck_Closing = 8
  Sck_Error = 9
  '
  ' States for SOCKS
  '
  SOCKS_Connected = 11
  SOCKS_Listening = 12
End Enum

Public Enum aeSocketReadDataEnum
  'Data is buffered
  DataBufferStream = 1
  'Data is new and not buffered (lost if not copied)
  DataDirectStream = 2
End Enum

'Called when a socket is set to an open state, it is ready
'to read/write *alias: connected*
'* RemotePeer  := address in noted form of remote computer
'* RemotePort  := port used on remote computer
'* LocalPort   := local port used
                 '
Public Sub Opened( _
    ByVal RemotePeer As String, ByVal RemotePort As Long, _
    ByVal LocalPeer As String, ByVal LocalPort As Long, _
    ByVal bFromListen As Boolean)

End Sub

'Called when a connection has been closed

'* RemotePeer     := address in noted form of remote computer
'* RemotePort     := port used on remote computer
'* bRemoteClosure := True if remote computer closed the connection
'* bGrace         := True if connection was terminated gracefully
'* bKeptData      := True if there is data left to be read
'                    It will go out of scope soon as this sub does!

'* Note: None of the parameters are refered to by the caller
Public Sub Closed( _
    ByVal RemotePeer As String, _
    ByVal RemotePort As Long, _
    ByVal bRemoteClosure As Boolean, _
    ByVal bGrace As Boolean, _
    ByVal bKeptData As Boolean)
    
End Sub

'Called when there is error information,
'context can be for API and/or connection, resolving problems.

'* ErrorCode   := ErrorCode from either API or defined error
'* ErrorString := String containing readable error meaning

'* Note: None of the parameters are refered to by the caller
Public Sub Error( _
    ByVal ErrorCode As Long, _
    ByVal ErrorString As String)

End Sub

'Called when a listening socket has a pending connection

'Before this event is fired a connection has already been made
'it has a new socket handle returned by 'accept' this is
'the only way to find out the remote peer information
'But the listening socket still exists, therefore this event
'is used to accept the connection and release the listening
'socket or accept it on another class and keep the
'listening socket

'This event is used in the Winsock control but it's meaning
'is not actually correct in the way it actually works.

'* RemotePeer := address in noted form of remote computer
'* RemotePort := port used on remote computer
'* SocketID   := new socket handle that the remote computer
'                connection was accepted on
'
'* Note: None of the parameters are refered to by the caller
Public Sub AcceptConnection( _
    ByVal RemotePeer As String, _
    ByVal RemotePort As Long, _
    ByVal SocketID As Long)

End Sub

'Called when a DNS look up has started

'* Host    := string being looked up
'* bIsHost := FALSE if host is an IP address

Public Sub DNSLookUpStarted( _
  ByVal Host As String, ByVal bIsHost As Boolean)
  
End Sub

'Called when a DNS look up is complete

'* Host             := Resolved host
'* bIsHost          := FALSE if Host is an IP address
'* PassedHost       := The passed host (That was looked up)
'* bError           := TRUE if there was an error
'* ErrorCode        := Error code
'* ErrorCodeMessage := Error description based on error code

Public Sub DNSLookUpDone( _
  ByVal Host As String, _
  ByVal bIsHost As Boolean, _
  ByVal PassedHost As String, _
  ByVal bError As Boolean, _
  ByVal ErrorCode As Long, _
  ByVal ErrorCodeMessage As String)

End Sub

'Called when the state of the current socket changes

'* NewState := Returns new state of socket
'
'Note: To get the old state, refer to aeSocket.State as it is
'      Still valid and the new state is set after this event
'      The 'StateDescription' property refers to the newest state always
Public Sub StateChanged( _
  ByVal NewState As aeSocketState)

End Sub

'Called when a new socket is created

'* NewHandle := Returns the new socket handle
'* SelfPtr   := Returns pointer to a aeSocket owning the socket
'               This is only included to make it easier
'               to find a socket class in an array/collection
'
' Note: aeSocket.Handle still refers to the OLD handle but
'       then is reassigned the new handle after this sub.
Public Sub SocketChanged( _
  ByVal NewHandle As Long, _
  ByVal SelfPtr As Long)
  
End Sub

'Called when there is data waiting to be read

'Note: Data given by this event is only new data as it read
'      Old data (kept in the buffer) can not be obtained
'      with this new data

'* BufferLen := Length in bytes of new data
'* Buffered  := Is the data buffered, you can only call
'               wsGetData if it's buffered
'* DataPtr   := Pointer to memory block
'* Data()    := Data as a byte array
'* IsOOB     := Is the data out of band?
Public Sub DataRead( _
  ByVal BufferLen As Long, _
  ByVal Buffered As aeSocketReadDataEnum, _
  ByVal DataPtr As Long, _
  Data() As Byte, _
  ByVal IsOOB As Boolean)
  
End Sub

'Called when a local socket or a remote one has been binded
'wsBindListen, also reports the same port if it's local
'
'* Port    := Port number binded
'* bRemote := Is the port local, maybe binded by SOCKS4/5
'
Public Sub Binded( _
  ByVal Port As Long, _
  ByVal bRemote As Boolean)

End Sub

'VB won't allow arrays with events, this sub
'is raised by the private function of 'EvtFace'
'which passes a reference to the current aeSocket
'the nice thing about this is, you can get events
'for any socket (even one in an array)
'it is called before any other sub in this interface
Public Sub thisaeSocket(ByVal ido As aeSocket)

End Sub
